/*
    rc Task
    
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
#include "device/at9s_pro.h"
#include "component/at9s_pro_cmd.h"
/* USER INCLUDE BEGIN */

/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
 uint8_t cmd_buffer[DEVICE_AT9S_FRAME_LEN];
 DEVICE_AT9S_t at9s;
 COMP_AT9S_CMD_t rc_cmd;
/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_rc(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / RC_FREQ;

  osDelay(RC_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */
  DEVICE_AT9S_Init(&at9s);
  DEVICE_AT9S_StartDmaRecv(cmd_buffer);
  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤 醒时刻 */
    /* USER CODE BEGIN */
    if (DEVICE_AT9S_WaitDmaCplt(10)) {
        DEVICE_AT9S_ParseRaw(cmd_buffer, &at9s);
		COMP_AT9S_CMD_ParseRc(&at9s, &rc_cmd);
        DEVICE_AT9S_StartDmaRecv(cmd_buffer);
    }
	
    osMessageQueuePut(task_runtime.msgq.shoot.rc_cmd, &rc_cmd, 0, 0);

    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}